/*******************************************************************************
 * Copyright (c) 2005 IBM Corporation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
package org.eclipse.stp.core.sca;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Module Reference</b></em>'.
 * <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link org.eclipse.stp.core.sca.ModuleReference#getExternalService <em>External Service</em>}</li>
 * </ul>
 * </p>
 * 
 * @see org.eclipse.stp.core.sca.SCAPackage#getModuleReference()
 * @model extendedMetaData="name='ModuleReference' kind='elementOnly'"
 * @generated
 */
public interface ModuleReference extends Reference {
   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * 
    * @generated
    */
   String copyright = "Copyright (c) 2005, 2006 IBM Corporation. Licensed Material - Property of IBM. All rights reserved."; //$NON-NLS-1$

   /**
    * Returns the value of the '<em><b>External Service</b></em>'
    * reference. <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>External Service</em>' containment
    * reference isn't clear, there really should be more of a description
    * here...
    * </p>
    * <!-- end-user-doc -->
    * 
    * @return the value of the '<em>External Service</em>' reference.
    * @see #setExternalService(ExternalService)
    * @see org.eclipse.stp.core.sca.SCAPackage#getModuleReference_ExternalService()
    * @model required="true" extendedMetaData="kind='element'
    *        name='externalService'"
    * @generated
    */
   ExternalService getExternalService();

   /**
    * Sets the value of the '{@link org.eclipse.stp.core.sca.ModuleReference#getExternalService <em>External Service</em>}'
    * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
    * 
    * @param value
    *           the new value of the '<em>External Service</em>' reference.
    * @see #getExternalService()
    * @generated
    */
   void setExternalService(ExternalService value);

} // ModuleReference
