/**
 * <copyright> </copyright>
 * 
 * $Id: EntryPointItemProvider.java,v 1.2 2006-04-05 14:26:13 melder Exp $
 */
package org.eclipse.stp.core.sca.provider;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.util.FeatureMap;
import org.eclipse.emf.ecore.util.FeatureMapUtil;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;
import org.eclipse.stp.core.internal.STPCorePlugin;
import org.eclipse.stp.core.sca.EntryPoint;
import org.eclipse.stp.core.sca.SCAFactory;
import org.eclipse.stp.core.sca.SCAPackage;

/**
 * This is the item provider adapter for a
 * {@link org.eclipse.stp.core.sca.EntryPoint} object. <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * 
 * @generated
 */
public class EntryPointItemProvider extends ItemProviderAdapter implements
      IEditingDomainItemProvider, IStructuredItemContentProvider,
      ITreeItemContentProvider, IItemLabelProvider, IItemPropertySource {
   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * 
    * @generated
    */
   public static final String copyright = "Copyright (c) 2005, 2006 IBM Corporation. Licensed Material - Property of IBM. All rights reserved."; //$NON-NLS-1$

   /**
    * This constructs an instance from a factory and a notifier. <!--
    * begin-user-doc --> <!-- end-user-doc -->
    * 
    * @generated
    */
   public EntryPointItemProvider(AdapterFactory adapterFactory) {
      super(adapterFactory);
   }

   /**
    * This returns the property descriptors for the adapted class. <!--
    * begin-user-doc --> <!-- end-user-doc -->
    * 
    * @generated
    */
   public List getPropertyDescriptors(Object object) {
      if (itemPropertyDescriptors == null) {
         super.getPropertyDescriptors(object);

         addMultiplicityPropertyDescriptor(object);
         addNamePropertyDescriptor(object);
      }
      return itemPropertyDescriptors;
   }

   /**
    * This adds a property descriptor for the Multiplicity feature. <!--
    * begin-user-doc --> <!-- end-user-doc -->
    * 
    * @generated
    */
   protected void addMultiplicityPropertyDescriptor(Object object) {
      itemPropertyDescriptors
            .add(createItemPropertyDescriptor(
                  ((ComposeableAdapterFactory) adapterFactory)
                        .getRootAdapterFactory(),
                  getResourceLocator(),
                  getString("_UI_EntryPoint_multiplicity_feature"), //$NON-NLS-1$
                  getString(
                        "_UI_PropertyDescriptor_description", "_UI_EntryPoint_multiplicity_feature", "_UI_EntryPoint_type"), //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
                  SCAPackage.eINSTANCE.getEntryPoint_Multiplicity(), true,
                  ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
   }

   /**
    * This adds a property descriptor for the Name feature. <!-- begin-user-doc
    * --> <!-- end-user-doc -->
    * 
    * @generated
    */
   protected void addNamePropertyDescriptor(Object object) {
      itemPropertyDescriptors
            .add(createItemPropertyDescriptor(
                  ((ComposeableAdapterFactory) adapterFactory)
                        .getRootAdapterFactory(),
                  getResourceLocator(),
                  getString("_UI_EntryPoint_name_feature"), //$NON-NLS-1$
                  getString(
                        "_UI_PropertyDescriptor_description", "_UI_EntryPoint_name_feature", "_UI_EntryPoint_type"), //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
                  SCAPackage.eINSTANCE.getEntryPoint_Name(), true,
                  ItemPropertyDescriptor.GENERIC_VALUE_IMAGE, null, null));
   }

   /**
    * This specifies how to implement {@link #getChildren} and is used to deduce
    * an appropriate feature for an
    * {@link org.eclipse.emf.edit.command.AddCommand},
    * {@link org.eclipse.emf.edit.command.RemoveCommand} or
    * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * 
    * @generated
    */
   public Collection getChildrenFeatures(Object object) {
      if (childrenFeatures == null) {
         super.getChildrenFeatures(object);
         childrenFeatures.add(SCAPackage.eINSTANCE
               .getEntryPoint_InterfaceGroup());
         childrenFeatures.add(SCAPackage.eINSTANCE.getEntryPoint_Interface());
         childrenFeatures
               .add(SCAPackage.eINSTANCE.getEntryPoint_BindingGroup());
         childrenFeatures.add(SCAPackage.eINSTANCE
               .getEntryPoint_ReferenceTargets());
         childrenFeatures.add(SCAPackage.eINSTANCE.getEntryPoint_Any());
         childrenFeatures
               .add(SCAPackage.eINSTANCE.getEntryPoint_AnyAttribute());
      }
      return childrenFeatures;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * 
    * @generated
    */
   protected EStructuralFeature getChildFeature(Object object, Object child) {
      // Check the type of the specified child object and return the proper
      // feature to use for
      // adding (see {@link AddCommand}) it as a child.

      return super.getChildFeature(object, child);
   }

   /**
    * This returns EntryPoint.gif. <!-- begin-user-doc --> <!-- end-user-doc -->
    * 
    * @generated
    */
   public Object getImage(Object object) {
      return getResourceLocator().getImage("full/obj16/EntryPoint"); //$NON-NLS-1$
   }

   /**
    * This returns the label text for the adapted class. <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * 
    * @generated
    */
   public String getText(Object object) {
      String label = ((EntryPoint) object).getName();
      return label == null || label.length() == 0 ? getString("_UI_EntryPoint_type") : //$NON-NLS-1$
            getString("_UI_EntryPoint_type") + " " + label; //$NON-NLS-1$ //$NON-NLS-2$
   }

   /**
    * This handles model notifications by calling {@link #updateChildren} to
    * update any cached children and by creating a viewer notification, which it
    * passes to {@link #fireNotifyChanged}. <!-- begin-user-doc --> <!--
    * end-user-doc -->
    * 
    * @generated
    */
   public void notifyChanged(Notification notification) {
      updateChildren(notification);

      switch (notification.getFeatureID(EntryPoint.class)) {
         case SCAPackage.ENTRY_POINT__MULTIPLICITY:
         case SCAPackage.ENTRY_POINT__NAME:
            fireNotifyChanged(new ViewerNotification(notification, notification
                  .getNotifier(), false, true));
            return;
         case SCAPackage.ENTRY_POINT__INTERFACE_GROUP:
         case SCAPackage.ENTRY_POINT__INTERFACE:
         case SCAPackage.ENTRY_POINT__BINDING_GROUP:
         case SCAPackage.ENTRY_POINT__REFERENCE_TARGETS:
         case SCAPackage.ENTRY_POINT__ANY:
         case SCAPackage.ENTRY_POINT__ANY_ATTRIBUTE:
            fireNotifyChanged(new ViewerNotification(notification, notification
                  .getNotifier(), true, false));
            return;
      }
      super.notifyChanged(notification);
   }

   /**
    * This adds to the collection of
    * {@link org.eclipse.emf.edit.command.CommandParameter}s describing all of
    * the children that can be created under this object. <!-- begin-user-doc
    * --> <!-- end-user-doc -->
    * 
    * @generated
    */
   protected void collectNewChildDescriptors(Collection newChildDescriptors,
         Object object) {
      super.collectNewChildDescriptors(newChildDescriptors, object);

      newChildDescriptors.add(createChildParameter(SCAPackage.eINSTANCE
            .getEntryPoint_InterfaceGroup(), FeatureMapUtil.createEntry(
            SCAPackage.eINSTANCE.getEntryPoint_Interface(),
            SCAFactory.eINSTANCE.createInterface())));

      newChildDescriptors.add(createChildParameter(SCAPackage.eINSTANCE
            .getEntryPoint_InterfaceGroup(), FeatureMapUtil.createEntry(
            SCAPackage.eINSTANCE.getEntryPoint_Interface(),
            SCAFactory.eINSTANCE.createJavaInterface())));

      newChildDescriptors.add(createChildParameter(SCAPackage.eINSTANCE
            .getEntryPoint_InterfaceGroup(), FeatureMapUtil.createEntry(
            SCAPackage.eINSTANCE.getEntryPoint_Interface(),
            SCAFactory.eINSTANCE.createWSDLPortType())));

      newChildDescriptors.add(createChildParameter(SCAPackage.eINSTANCE
            .getEntryPoint_InterfaceGroup(), FeatureMapUtil.createEntry(
            SCAPackage.eINSTANCE.getSCACoreRoot_InterfaceWsdl(),
            SCAFactory.eINSTANCE.createWSDLPortType())));

      newChildDescriptors.add(createChildParameter(SCAPackage.eINSTANCE
            .getEntryPoint_InterfaceGroup(), FeatureMapUtil.createEntry(
            SCAPackage.eINSTANCE.getSCACoreRoot_InterfaceJava(),
            SCAFactory.eINSTANCE.createJavaInterface())));

      newChildDescriptors
            .add(createChildParameter(SCAPackage.eINSTANCE
                  .getEntryPoint_Interface(), SCAFactory.eINSTANCE
                  .createInterface()));

      newChildDescriptors.add(createChildParameter(SCAPackage.eINSTANCE
            .getEntryPoint_Interface(), SCAFactory.eINSTANCE
            .createJavaInterface()));

      newChildDescriptors.add(createChildParameter(SCAPackage.eINSTANCE
            .getEntryPoint_Interface(), SCAFactory.eINSTANCE
            .createWSDLPortType()));

      newChildDescriptors.add(createChildParameter(SCAPackage.eINSTANCE
            .getEntryPoint_BindingGroup(), FeatureMapUtil.createEntry(
            SCAPackage.eINSTANCE.getEntryPoint_Bindings(), SCAFactory.eINSTANCE
                  .createBinding())));

      newChildDescriptors.add(createChildParameter(SCAPackage.eINSTANCE
            .getEntryPoint_BindingGroup(), FeatureMapUtil.createEntry(
            SCAPackage.eINSTANCE.getEntryPoint_Bindings(), SCAFactory.eINSTANCE
                  .createSCABinding())));

      newChildDescriptors.add(createChildParameter(SCAPackage.eINSTANCE
            .getEntryPoint_BindingGroup(), FeatureMapUtil.createEntry(
            SCAPackage.eINSTANCE.getEntryPoint_Bindings(), SCAFactory.eINSTANCE
                  .createSLSBBinding())));

      newChildDescriptors.add(createChildParameter(SCAPackage.eINSTANCE
            .getEntryPoint_BindingGroup(), FeatureMapUtil.createEntry(
            SCAPackage.eINSTANCE.getEntryPoint_Bindings(), SCAFactory.eINSTANCE
                  .createWebServiceBinding())));

      newChildDescriptors.add(createChildParameter(SCAPackage.eINSTANCE
            .getEntryPoint_BindingGroup(), FeatureMapUtil.createEntry(
            SCAPackage.eINSTANCE.getSCACoreRoot_BindingSca(),
            SCAFactory.eINSTANCE.createSCABinding())));

      newChildDescriptors.add(createChildParameter(SCAPackage.eINSTANCE
            .getEntryPoint_BindingGroup(), FeatureMapUtil.createEntry(
            SCAPackage.eINSTANCE.getSCACoreRoot_BindingWs(),
            SCAFactory.eINSTANCE.createWebServiceBinding())));

      newChildDescriptors.add(createChildParameter(SCAPackage.eINSTANCE
            .getEntryPoint_BindingGroup(), FeatureMapUtil.createEntry(
            SCAPackage.eINSTANCE.getSCACoreRoot_BindingEjb(),
            SCAFactory.eINSTANCE.createSLSBBinding())));

      newChildDescriptors.add(createChildParameter(SCAPackage.eINSTANCE
            .getEntryPoint_ReferenceTargets(), "")); //$NON-NLS-1$
   }

   /**
    * This returns the label text for
    * {@link org.eclipse.emf.edit.command.CreateChildCommand}. <!--
    * begin-user-doc --> <!-- end-user-doc -->
    * 
    * @generated
    */
   public String getCreateChildText(Object owner, Object feature, Object child,
         Collection selection) {
      Object childFeature = feature;
      Object childObject = child;

      if (childFeature instanceof EStructuralFeature
            && FeatureMapUtil.isFeatureMap((EStructuralFeature) childFeature)) {
         FeatureMap.Entry entry = (FeatureMap.Entry) childObject;
         childFeature = entry.getEStructuralFeature();
         childObject = entry.getValue();
      }

      boolean qualify = childFeature == SCAPackage.eINSTANCE
            .getEntryPoint_Interface()
            || childFeature == SCAPackage.eINSTANCE
                  .getSCACoreRoot_InterfaceJava()
            || childFeature == SCAPackage.eINSTANCE
                  .getSCACoreRoot_InterfaceWsdl()
            || childFeature == SCAPackage.eINSTANCE.getEntryPoint_Bindings()
            || childFeature == SCAPackage.eINSTANCE.getSCACoreRoot_BindingSca()
            || childFeature == SCAPackage.eINSTANCE.getSCACoreRoot_BindingEjb()
            || childFeature == SCAPackage.eINSTANCE.getSCACoreRoot_BindingWs();

      if (qualify) {
         return getString("_UI_CreateChild_text2", //$NON-NLS-1$
               new Object[] { getTypeText(childObject),
                     getFeatureText(childFeature), getTypeText(owner) });
      }
      return super.getCreateChildText(owner, feature, child, selection);
   }

   /**
    * Return the resource locator for this item provider's resources. <!--
    * begin-user-doc --> <!-- end-user-doc -->
    * 
    * @generated
    */
   public ResourceLocator getResourceLocator() {
      return STPCorePlugin.INSTANCE;
   }

}
